Index: imaps-backend/.gitignore
===================================================================
--- imaps-backend/.gitignore	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/.gitignore	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
Index: imaps-backend/backendRender/.gitignore
===================================================================
--- imaps-backend/backendRender/.gitignore	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/backendRender/.gitignore	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/BackendRenderApplication.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/BackendRenderApplication.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/BackendRenderApplication.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -3,9 +3,4 @@
 import org.springframework.boot.SpringApplication;
 import org.springframework.boot.autoconfigure.SpringBootApplication;
-import org.springframework.context.annotation.Bean;
-import org.springframework.mail.javamail.JavaMailSender;
-import org.springframework.mail.javamail.JavaMailSenderImpl;
-import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
-import org.springframework.security.crypto.password.PasswordEncoder;
 
 @SpringBootApplication
@@ -16,8 +11,3 @@
 	}
 
-	@Bean
-	public PasswordEncoder passwordEncoder(){
-		return new BCryptPasswordEncoder(12);
-	}
-
 }
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/Edge.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/Edge.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/Edge.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -4,10 +4,8 @@
 import lombok.Getter;
 import lombok.Setter;
-import lombok.ToString;
 
 import java.util.Map;
 
 @Setter @Getter
-@ToString
 public class Edge{
   private MapNode node;
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/MapNode.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/MapNode.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/MapNode.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -14,13 +14,9 @@
     private Coordinates<Double,Double> coordinates;
     private List<String> connectionNames = new ArrayList<>();
-    private String className;
-    private int floorNumber;
 
-    public MapNode(String name, String description, Coordinates<Double, Double> coordinates,String className,int floorNumber) {
+    public MapNode(String name, String description, Coordinates<Double, Double> coordinates) {
         this.name = name;
         this.description = description;
         this.coordinates = coordinates;
-        this.className = className;
-        this.floorNumber = floorNumber;
     }
 
@@ -31,4 +27,10 @@
     }
 
+    public MapNode(String name, String description, Coordinates<Double, Double> coordinates, String connectedRoom) {
+        this.name = name;
+        this.description = description;
+        this.coordinates = coordinates;
+        this.connectedRoom = connectedRoom;
+    }
 
     public MapNode() {
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/MapNodeParser.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/MapNodeParser.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/MapNodeParser.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -2,4 +2,5 @@
 
 
+import com.fasterxml.jackson.core.JsonProcessingException;
 import com.fasterxml.jackson.databind.JsonNode;
 import com.fasterxml.jackson.databind.ObjectMapper;
@@ -9,50 +10,72 @@
 
 public class MapNodeParser {
-
-
-    public List<MapNode> parseAndCreate(String mapJson) throws Exception {
+    public List<MapNode> parseAndCreateNodes(String mapJson) throws Exception {
         final List<MapNode> mapNodes = new ArrayList<>();
 
-        if (mapJson == null || mapJson.isEmpty() || mapJson.equals("[]")) {
-            throw new MapParseException("Cannot parse empty map");
-        }
+        System.out.println("======= MAP JSON ====== " + mapJson);
+
+//        if(mapJson == null || mapJson.isEmpty() || mapJson.equals("[]")) {
+//            throw new MapParseException("Cannot parse empty map");
+//        }
 
         ObjectMapper objectMapper = new ObjectMapper();
-        List<Shape> shapes = objectMapper.readValue(mapJson, objectMapper.getTypeFactory().constructCollectionType(List.class, Shape.class));
+            String[] shapes = objectMapper.readValue(mapJson, String[].class);
 
-        shapes.forEach(shape -> {
-            try {
-                String type = shape.getClassName();
-                if (Objects.equals(type, "Wall") || Objects.equals(type, "Room")) return;
-                MapNode mapNode = createMapNode(shape);
-                @SuppressWarnings("unchecked")
-                List<String> connectedPins = (List<String>) shape.getAttrs().get("connected_pins");
-                if (connectedPins != null) {
-                    for (String pin : connectedPins) {
-                        System.out.println("Connected node (markup) : " + pin + " to: " + shape.getAttrs().get("obj_name"));
-                        mapNode.addConnectionName(pin);
+            Arrays.stream(shapes).forEach(shape -> {
+                try {
+                    JsonNode parsedNode = objectMapper.readTree(shape);
+                    String type = parsedNode.get("className").asText();
+
+                    // Wall i room ne se bitni za navigacija
+                    if(Objects.equals(type,"Wall") || Objects.equals(type,"Room")) return;
+
+                    JsonNode attrs = parsedNode.get("attrs");
+                    MapNode mapNode = createMapNode(attrs);
+
+                    if(attrs.has("connected_pins")){
+                        JsonNode connectedPins = attrs.get("connected_pins");
+                        if (connectedPins.isArray()) {
+                            for (JsonNode pin : connectedPins) {
+                                System.out.println("Connected node (markup) : " + pin.asText() + " to: " + attrs.get("obj_name"));
+                                mapNode.addConnectionName(pin.asText());
+                            }
+                        }
                     }
+
+                    mapNodes.add(mapNode);
+
+                } catch (JsonProcessingException e) {
+                    throw new RuntimeException(e);
                 }
-                mapNodes.add(mapNode);
-            } catch (Exception e) {
-                throw new RuntimeException(e);
-            }
-        });
-        mapNodes.forEach(node -> System.out.println("Added node: ----> " + node.toString()));
-        return mapNodes;
+            });
+
+           mapNodes.forEach(node -> System.out.println("Added node: ----> " + node.toString()));
+
+           return mapNodes;
+
     }
 
 
-    private static MapNode createMapNode(Shape shape) {
-        String name = (String) shape.getAttrs().get("obj_name");
-        String description = (String) shape.getAttrs().get("description");
-        String connectedRoom = (String) shape.getAttrs().get("connected_room");
-        double x = Double.parseDouble(Objects.requireNonNull(shape.getAttrs().get("x")).toString());
-        double y = Double.parseDouble(Objects.requireNonNull(shape.getAttrs().get("y")).toString());
-        Coordinates<Double, Double> coordinates = new Coordinates<>(x, y);
-        int floorNumber = (int) shape.getAttrs().get("floor_num");
+    private static String findAttr(String key,JsonNode attrs){
+        if(attrs.has(key)){
+            return attrs.get(key).asText();
+        } else {
+            System.out.println("No attribute found for key:" + key);
+            return null;
+        }
 
-        MapNode mapNode = new MapNode(name, description, coordinates, shape.getClassName(), floorNumber);
-        if (connectedRoom != null) {
+    }
+
+
+    private static MapNode createMapNode(JsonNode attrs) {
+        String name = findAttr("obj_name",attrs);
+        String description = findAttr("description",attrs);
+        String connectedRoom = findAttr("connected_room",attrs);
+        double x = Double.parseDouble(Objects.requireNonNull(findAttr("x", attrs)));
+        double y = Double.parseDouble(Objects.requireNonNull(findAttr("y", attrs)));
+        Coordinates<Double,Double> coordinates = new Coordinates<>(x,y);
+
+        MapNode mapNode = new MapNode(name, description, coordinates);
+        if(connectedRoom != null){
             mapNode.setConnectedRoom(connectedRoom);
         }
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/RouteGraph.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/RouteGraph.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/graph/RouteGraph.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -7,24 +7,16 @@
     private final Map<String, MapNode> nameToNodeMap = new HashMap<>();
 
+    public RouteGraph(List<MapNode> nodes) {
 
-    public void loadNodeNames(List<MapNode> nodes){
+
         for (MapNode node : nodes) {
             nameToNodeMap.put(node.getName(), node);
         }
 
-        for(Map.Entry<String,MapNode> entries : nameToNodeMap.entrySet()) {
-            System.out.println(entries.getKey() + " " + entries.getValue());
-        }
-    }
-
-    public void loadEdges(){
-        for (MapNode mapNode : nameToNodeMap.values()) {
+        for (MapNode mapNode : nodes) {
             for (String connectionName : mapNode.getConnectionNames()) {
-                System.out.println("CONN: " + mapNode.getName() + " " + connectionName);
                 MapNode connectedNode = nameToNodeMap.get(connectionName);
                 if (connectedNode != null) {
                     addEdge(mapNode, connectedNode);
-                }else {
-                    System.out.println("CANT ADD EDGE ========== " + "FROM: " + mapNode.getName() + " TO: " + connectionName);
                 }
             }
@@ -36,5 +28,4 @@
         double x1 = a.getCoordinates().x;
         double y1 = a.getCoordinates().y;
-
         double x2 = b.getCoordinates().x;
         double y2 = b.getCoordinates().y;
@@ -51,6 +42,4 @@
         if (sourceNode == null || targetNode == null) {
             System.out.println(this.toString());
-            System.out.println("SOURCE NODE FROM MAP " + sourceNode);
-            System.out.println("TARGET NODE FROM MAP " + targetNode);
             throw new IllegalArgumentException("Source or target node not found. SOURCE: " + source + " TARGET: " + target);
         }
@@ -106,8 +95,7 @@
         }
 
-        Collections.reverse(path);// deka se staveni vo obraten redosled, pa reverse ni dava pateka od pocetok do kraj.
+        Collections.reverse(path); // deka se staveni vo obraten redosled, pa reverse ni dava pateka od pocetok do kraj.
 
         if (!path.isEmpty() && path.get(0).equals(sourceNode)) {
-            System.out.println("FOUND PATH: " + path);
             return path;
         } else {
@@ -141,6 +129,10 @@
         }
         return null;
-        //throw new IllegalArgumentException("Cant find room connected to entrance: " + roomName);
     }
+
+    public String getNodeNameByName(String name){
+        return nameToNodeMap.get(name).getName();
+    }
+
 
 
@@ -153,6 +145,4 @@
             MapNode node = entry.getKey();
             Set<Edge> connectedNodes = entry.getValue();
-
-            System.out.println("CONN NODES PRINT: " + connectedNodes);
 
             sb.append(node.getName()).append(" -> ");
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/config/MapConfig.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/config/MapConfig.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/config/MapConfig.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,46 @@
+//package internettehnologii.imaps.backendRender.web.config;
+//
+//import internettehnologii.imaps.backendRender.web.entities.IndoorMap;
+//import internettehnologii.imaps.backendRender.web.repo.MapRepository;
+//import internettehnologii.imaps.backendRender.web.security.json.DataJson;
+//import org.springframework.boot.CommandLineRunner;
+//import org.springframework.context.annotation.Bean;
+//import org.springframework.context.annotation.Configuration;
+//
+//import java.util.List;
+//
+//@Configuration
+//public class MapConfig {
+//    String jsonTest1 = "{\n" +
+//            "  \"id\": 1,\n" +
+//            "  \"name\": \"Sample Map\",\n" +
+//            "  \"mapData\": {\n" +
+//            "    \"type\": \"2D\",\n" +
+//            "    \"features\": [\n" +
+//            "      {\"name\": \"River\", \"location\": {\"x\": 10, \"y\": 20}},\n" +
+//            "      {\"name\": \"Mountain\", \"location\": {\"x\": 30, \"y\": 40}}\n" +
+//            "    ]\n" +
+//            "  },\n" +
+//            "  \"graphData\": {\n" +
+//            "    \"nodes\": [\n" +
+//            "      {\"id\": \"A\", \"label\": \"Start\"},\n" +
+//            "      {\"id\": \"B\", \"label\": \"Finish\"}\n" +
+//            "    ],\n" +
+//            "    \"edges\": [\n" +
+//            "      {\"source\": \"A\", \"target\": \"B\", \"weight\": 5}\n" +
+//            "    ]\n" +
+//            "  },\n" +
+//            "  \"isPublic\": true,\n" +
+//            "  \"url\": \"http://example.com/map\"\n" +
+//            "}\n";
+//    @Bean
+//    CommandLineRunner mapCmdLineRunner(MapRepository repository){
+//        return args -> {
+//            IndoorMap martin = new IndoorMap("MARTINCE",new DataJson(jsonTest1),true, "url");
+//            IndoorMap stefan = new IndoorMap("STEFCE", new DataJson(jsonTest1), true, "url");
+//            repository.saveAll(
+//                    List.of(martin, stefan)
+//            );
+//        };
+//    };
+//}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/config/UserConfig.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/config/UserConfig.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/config/UserConfig.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,27 @@
+//package internettehnologii.imaps.backendRender.web.config;
+//
+//import internettehnologii.imaps.backendRender.web.entities.IMapsUser;
+//import internettehnologii.imaps.backendRender.web.repo.UserRepository;
+//import org.springframework.boot.CommandLineRunner;
+//import org.springframework.context.annotation.Bean;
+//import org.springframework.context.annotation.Configuration;
+//import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
+//
+//import java.util.List;
+//
+//@Configuration
+//public class UserConfig {
+//
+//    BCryptPasswordEncoder bCryptPasswordEncoder = new BCryptPasswordEncoder(12);
+//    @Bean
+//    CommandLineRunner commandLineRunner(UserRepository repository){
+//        return args -> {
+//            IMapsUser martin = new IMapsUser("martin", "martindjakov03@gmail.com", bCryptPasswordEncoder.encode("dzako"));
+//            IMapsUser stefan = new IMapsUser( "stefan", "stefantoskovski03@gmail.com", bCryptPasswordEncoder.encode("toska"));
+//            repository.saveAll(
+//                    List.of(martin, stefan)
+//            );
+//        };
+//
+//    };
+//}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/AuthController.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/AuthController.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/AuthController.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -2,30 +2,24 @@
 
 import internettehnologii.imaps.backendRender.web.entities.IMapsUser;
-import internettehnologii.imaps.backendRender.web.entities.IndoorMap;
-import internettehnologii.imaps.backendRender.web.service.impl.JWTService;
-import internettehnologii.imaps.backendRender.web.service.impl.MapUserDetailsService;
-import internettehnologii.imaps.backendRender.web.service.impl.UserServiceImpl;
-import internettehnologii.imaps.backendRender.web.service.interfaces.MapService;
-import internettehnologii.imaps.backendRender.web.util.DTO.UserAuthSuccessDTO;
-import internettehnologii.imaps.backendRender.web.util.DTO.UserLoginDTO;
+import internettehnologii.imaps.backendRender.web.service.JWTService;
+import internettehnologii.imaps.backendRender.web.service.MapUserDetailsService;
+import internettehnologii.imaps.backendRender.web.service.UserService;
 import jakarta.servlet.http.HttpServletRequest;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.context.ApplicationContext;
-import org.springframework.http.ResponseEntity;
 import org.springframework.security.core.userdetails.UserDetails;
-import org.springframework.security.core.userdetails.UserDetailsService;
 import org.springframework.web.bind.annotation.*;
 
-import javax.management.relation.RoleNotFoundException;
 import java.util.HashMap;
+import java.util.List;
 import java.util.Map;
 
 @RequestMapping("/api/auth")
 @RestController
-//@CrossOrigin(origins = "http://localhost:5173")
+@CrossOrigin(origins = "http://localhost:5173/")
 public class AuthController {
 
     @Autowired
-    private UserServiceImpl userService;
+    private UserService userService;
     @Autowired
     private JWTService jwtService;
@@ -35,30 +29,27 @@
 
     @PostMapping("/register")
-    public IMapsUser register(@RequestBody IMapsUser user) throws RoleNotFoundException {
+    public IMapsUser register(@RequestBody IMapsUser user) {
         return userService.register(user);
     }
 
     @PostMapping("/login")
-    public Map<String, Object> login(@RequestBody UserLoginDTO user) {
+    public Map<String, Object> login(@RequestBody IMapsUser user, HttpServletRequest request) {
         System.out.println(user);
         Map<String, Object> response = new HashMap<>();
-
-        try{
-            UserAuthSuccessDTO userAuthSuccessDTO = userService.login(user);
-            response.put("token", userAuthSuccessDTO.getToken());
-            response.put("username", userAuthSuccessDTO.getUsername());
-            response.put("roles", userAuthSuccessDTO.getRoles());
-        } catch (Exception e){
-            System.out.println(e.getMessage());
-            response.put("error", e.getMessage());
-        }
-
+        String token = userService.verify(user);
+        response.put("token", token);
+        response.put("username", user.getUsername());
         return response;
     }
 
 
+    //ZA TESTIRANJE
+    @GetMapping("/list")
+    public List<IMapsUser> showUsers() {
+        return userService.getUsers();
+    }
+
     @GetMapping("/verify")
-    public ResponseEntity<Map<String,Object>> authenticateUser(@RequestParam String token) {
-        System.out.println("VERIFY");
+    public Map<String,Object> authenticateUser(@RequestParam String token) {
         Map<String, Object> response = new HashMap<>();
         try{
@@ -66,27 +57,15 @@
             UserDetails userDetails = context.getBean(MapUserDetailsService.class).loadUserByUsername(username);
             boolean auth = jwtService.validateToken(token, userDetails);
-
-            if(!auth){
-                response.put("error", "Token could not be validated");
-                return ResponseEntity.status(403).body(response);
+            if(auth){
+                response.put("username", username);
             }
 
-            response.put("username", username);
-            System.out.println("Authenticated user: " + username);
+            System.out.println(auth + " auth");
         } catch (Exception e){
-            response.put("auth",false);
             System.out.println("ERROR: NOT AUTHENTICATED: " + e.getMessage());
         }
 
-        return ResponseEntity.ok(response);
+        return response;
 
     }
-
-    @GetMapping("/test_auth")
-    public ResponseEntity<Map<String,Object>> testAuth(){
-        Map<String, Object> response = new HashMap<>();
-        response.put("auth",true);
-        return ResponseEntity.ok(response);
-    }
-
 }
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapController.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapController.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapController.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,83 @@
+package internettehnologii.imaps.backendRender.web.controllers;
+
+import internettehnologii.imaps.backendRender.web.entities.IndoorMap;
+import internettehnologii.imaps.backendRender.web.service.MapService;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.http.HttpStatus;
+import org.springframework.http.ResponseEntity;
+import org.springframework.web.bind.annotation.*;
+
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Optional;
+
+@RestController
+@RequestMapping(path = "/api")
+public class MapController {
+    private final MapService mapService;
+
+    @Autowired
+    public MapController(MapService mapService){
+        this.mapService = mapService;
+    }
+
+    @GetMapping("/protected/maps")
+    public List<IndoorMap> getMaps(){
+        return mapService.getMaps();
+    }
+
+    @PutMapping("/protected/maps/save")
+    public ResponseEntity<Map<String,Object>> saveMap(@RequestBody String mapData, @RequestParam String mapName) {
+        HashMap<String,Object> response = new HashMap<>();
+        try {
+            mapService.saveMap(mapName, mapData);
+            response.put("status","ok");
+            Optional<IndoorMap> map = mapService.getMapByName(mapName);
+            if(map.isPresent()){
+                response.put("map",map.get());
+            } else {
+                response.put("map","rip");
+            }
+
+            return ResponseEntity.ok(response);
+        } catch (Exception e) {
+            System.out.println(e.getMessage());
+            e.printStackTrace();
+            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR)
+                    .body(response);
+        }
+    }
+
+    @GetMapping("/protected/maps/load")
+    public ResponseEntity<Map<String,Object>> loadMap(@RequestParam String mapName) {
+        HashMap<String,Object> response = new HashMap<>();
+        Optional<IndoorMap> map = mapService.getMapByName(mapName);
+        if (map.isPresent()) {
+            response.put("status","ok");
+            response.put("map",map.get());
+            return ResponseEntity.ok(response);
+        } else {
+            response.put("status","error: map " + mapName + " not found");
+        }
+        return ResponseEntity.ok(response);
+    }
+
+//    @PostMapping
+//    public void registerNewMap(@RequestBody IndoorMap map){
+//        mapService.addNewMap(map);
+//    }
+//
+//    @DeleteMapping(path = "{mapId}")
+//    public void deleteMap(@PathVariable("mapId") Long mapId){
+//        mapService.deleteMap(mapId);
+//    }
+//
+//    @PutMapping(path = "{mapId}")
+//    public void updateMap(
+//            @PathVariable("mapId") Long mapId,
+//            @RequestParam(required = false) String name){
+//
+//        //mapService.updateMap(name);
+//    }
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapRenderApi.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapRenderApi.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapRenderApi.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,82 @@
+package internettehnologii.imaps.backendRender.web.controllers;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import internettehnologii.imaps.backendRender.graph.MapNode;
+import internettehnologii.imaps.backendRender.graph.MapNodeParser;
+import internettehnologii.imaps.backendRender.graph.RouteGraph;
+import internettehnologii.imaps.backendRender.graph.exceptions.MapParseException;
+import internettehnologii.imaps.backendRender.graph.exceptions.NodeNotFoundException;
+import internettehnologii.imaps.backendRender.web.entities.IndoorMap;
+import internettehnologii.imaps.backendRender.web.service.MapService;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.http.HttpStatus;
+import org.springframework.http.ResponseEntity;
+import org.springframework.web.bind.annotation.*;
+import org.springframework.web.context.request.NativeWebRequest;
+
+import java.util.*;
+
+@RestController
+@RequestMapping("/api")
+@CrossOrigin(origins = "http://localhost:5173/", allowedHeaders = {"Authorization"})
+public class MapRenderApi {
+
+    private String jsonData;
+    private RouteGraph graph;
+
+    private final MapService mapService;
+
+    @Autowired
+    public MapRenderApi(MapService mapService) {
+        this.mapService = mapService;
+    }
+
+    @PostMapping("/protected/render")
+    public ResponseEntity<Map<String, Object>> render(@RequestBody String requestBody) throws Exception {
+        Map<String, Object> response = new HashMap<>();
+        response.put("status", "ok");
+        jsonData = requestBody;
+        try {
+            MapNodeParser parser = new MapNodeParser();
+            List<MapNode> nodes = parser.parseAndCreateNodes(requestBody);
+            graph = new RouteGraph(nodes);
+            System.out.println("=======================\n" + graph);
+        } catch (MapParseException e) {
+            response.put("status", "error: " + e.getMessage());
+        }
+
+        return ResponseEntity.ok(response);
+    }
+
+
+    @GetMapping("/public/navigate")
+    public ResponseEntity<List<MapNode>> navigate(@RequestParam String from, @RequestParam String to) {
+
+        String startNode = from;
+        String endNode = to;
+
+        String roomConnectedToEntranceFrom = graph.findNodeConnectedToEntrance(from);
+        String roomConnectedToEntranceTo = graph.findNodeConnectedToEntrance(to);
+        if (roomConnectedToEntranceFrom != null) {
+            startNode = roomConnectedToEntranceFrom;
+        }
+        if (roomConnectedToEntranceTo != null) {
+            endNode = roomConnectedToEntranceTo;
+        }
+
+        List<MapNode> path = graph.findRoute(startNode, endNode);
+        return ResponseEntity.ok(path);
+    }
+
+    @GetMapping("/public/mapData")
+    public ResponseEntity<String> getMapData() {
+        //tuka povik do baza
+        System.out.println(jsonData);
+        if (jsonData != null && !jsonData.isEmpty()) {
+            return ResponseEntity.ok(jsonData);
+        } else {
+            return ResponseEntity.notFound().build();
+        }
+    }
+
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/UserController.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/UserController.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/UserController.java	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,40 @@
+package internettehnologii.imaps.backendRender.web.controllers;
+
+import internettehnologii.imaps.backendRender.web.entities.IMapsUser;
+import internettehnologii.imaps.backendRender.web.service.UserService;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.web.bind.annotation.*;
+
+import java.util.List;
+
+
+//test klasa
+@RestController
+@RequestMapping(path = "api/v1/user")
+public class UserController {
+    private final UserService userService;
+
+    @Autowired
+    public UserController(UserService userService){
+        this.userService = userService;
+    }
+
+    @GetMapping
+    public List<IMapsUser> getUsers(){
+        return userService.getUsers();
+    }
+
+
+    @DeleteMapping(path = "{userId}")
+    public void deleteUser(@PathVariable("userId") Long userId){
+        userService.deleteUser(userId);
+    }
+
+    @PutMapping(path = "{userId}")
+    public void updateUser(
+            @PathVariable("userId") Long userId,
+            @RequestParam(required = false) String name,
+            @RequestParam(required = false) String email){
+        userService.updateUser(userId, name, email);
+    }
+}
